about summary refs log tree commit diff
path: root/tests/repair.sh
diff options
context:
space:
mode:
authorEelco Dolstra <eelco.dolstra@logicblox.com>2014-02-17T11·22+0100
committerEelco Dolstra <eelco.dolstra@logicblox.com>2014-02-17T11·22+0100
commit832377bbd6ccd43895ac346131cafe4901f7996b (patch)
tree427b36821bdb5c0bd6d2336df157c300e95b66f1 /tests/repair.sh
parenta9d99ab55fdaa1c9dde87eaa8d289ecdb8cf9068 (diff)
Add a test for repairing paths
Diffstat (limited to 'tests/repair.sh')
-rw-r--r--tests/repair.sh47
1 files changed, 47 insertions, 0 deletions
diff --git a/tests/repair.sh b/tests/repair.sh
new file mode 100644
index 0000000000..f17aef2771
--- /dev/null
+++ b/tests/repair.sh
@@ -0,0 +1,47 @@
+source common.sh
+
+clearStore
+
+path=$(nix-build dependencies.nix -o $TEST_ROOT/result)
+path2=$(nix-store -qR $path | grep input-2)
+
+nix-store --verify --check-contents -v
+
+hash=$(nix-hash $path2)
+
+# Corrupt a path and check whether nix-build --repair can fix it.
+chmod u+w $path2
+touch $path2/bad
+
+if nix-store --verify --check-contents -v; then
+    echo "nix-store --verify succeeded unexpectedly" >&2
+    exit 1
+fi
+
+if nix-store --verify --check-contents --repair; then
+    echo "nix-store --verify --repair succeeded unexpectedly" >&2
+    exit 1
+fi
+
+nix-build dependencies.nix -o $TEST_ROOT/result --repair
+
+if [ "$(nix-hash $path2)" != "$hash" -o -e $path2/bad ]; then
+    echo "path not repaired properly" >&2
+    exit 1
+fi
+
+# Corrupt a path that has a substitute and check whether nix-store
+# --verify can fix it.
+clearCache
+
+nix-push --dest $cacheDir $path
+
+chmod u+w $path2
+rm -rf $path2
+
+nix-store --verify --check-contents --repair --option binary-caches "file://$cacheDir"
+
+if [ "$(nix-hash $path2)" != "$hash" -o -e $path2/bad ]; then
+    echo "path not repaired properly" >&2
+    exit 1
+fi